summaryrefslogtreecommitdiffstats
path: root/development/rustup/rustup.SlackBuild
diff options
context:
space:
mode:
author Andrew Clemons <andrew.clemons@gmail.com>2018-03-22 21:43:27 +0000
committer David Spencer <idlemoor@slackbuilds.org>2018-03-22 21:43:27 +0000
commit61cd09e0c8061a2b1735cc84fc25224d9f5e2302 (patch)
tree022c7abdf93f3504b31760d546b237910d2dbdab /development/rustup/rustup.SlackBuild
parentcde5bc7030d34bdabc6ec7a094e355318d331c83 (diff)
downloadslackbuilds-61cd09e0c8061a2b1735cc84fc25224d9f5e2302.tar.gz
slackbuilds-61cd09e0c8061a2b1735cc84fc25224d9f5e2302.tar.xz
development/rustup: Added (The Rust toolchain installer).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'development/rustup/rustup.SlackBuild')
-rw-r--r--development/rustup/rustup.SlackBuild312
1 files changed, 312 insertions, 0 deletions
diff --git a/development/rustup/rustup.SlackBuild b/development/rustup/rustup.SlackBuild
new file mode 100644
index 0000000000..02c8a8bf22
--- /dev/null
+++ b/development/rustup/rustup.SlackBuild
@@ -0,0 +1,312 @@
+#!/bin/sh
+
+# Slackware build script for rustup
+
+# Copyright 2017-2018 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=rustup
+VERSION=${VERSION:-1.11.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+
+ if [ "$ARCH" = "i586" ]; then
+ if rustc -Vv | grep host | grep i686 > /dev/null ; then
+ ARCH=i686
+ fi
+ fi
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ CARGOTARGET="--target i586-unknown-linux-gnu"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ CARGOTARGET="--target i686-unknown-linux-gnu"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ CARGOTARGET="--target x86_64-unknown-linux-gnu"
+else
+ SLKCFLAGS="-O2"
+ CARGOTARGET=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM.rs-$VERSION
+tar xvf $CWD/$PRGNAM.rs-$VERSION.tar.gz
+cd $PRGNAM.rs-$VERSION
+
+# build offline
+# configuration tells cargo to use the configured directory
+# for dependencies intead of downloading from crates.io
+mkdir .cargo
+cat << EOF >> .cargo/config
+[source.crates-io]
+registry = 'https://github.com/rust-lang/crates.io-index'
+replace-with = 'vendored-sources'
+
+[source.vendored-sources]
+directory = '$(pwd)/vendor'
+EOF
+
+# deps and versions come from Cargo.lock
+mkdir vendor
+(
+ cd vendor
+
+ for dependency in adler32=1.0.2 \
+ aho-corasick=0.5.3 \
+ aho-corasick=0.6.4 \
+ ansi_term=0.10.2 \
+ arrayref=0.3.4 \
+ atty=0.2.6 \
+ backtrace-sys=0.1.16 \
+ backtrace=0.3.5 \
+ base64=0.9.0 \
+ bitflags=0.9.1 \
+ bitflags=1.0.1 \
+ block-buffer=0.3.3 \
+ build_const=0.2.0 \
+ byte-tools=0.2.0 \
+ byteorder=1.2.1 \
+ bytes=0.4.6 \
+ cc=1.0.4 \
+ cfg-if=0.1.2 \
+ clap=2.30.0 \
+ core-foundation-sys=0.2.3 \
+ core-foundation=0.2.3 \
+ crc=1.7.0 \
+ curl-sys=0.4.1 \
+ curl=0.4.11 \
+ digest=0.7.2 \
+ dtoa=0.4.2 \
+ either=1.4.0 \
+ env_proxy=0.2.0 \
+ error-chain=0.11.0 \
+ fake-simd=0.1.2 \
+ filetime=0.1.15 \
+ flate2=1.0.1 \
+ foreign-types-shared=0.1.1 \
+ foreign-types=0.3.2 \
+ fuchsia-zircon-sys=0.3.3 \
+ fuchsia-zircon=0.3.3 \
+ futures-cpupool=0.1.8 \
+ futures=0.1.18 \
+ gcc=0.3.54 \
+ generic-array=0.9.0 \
+ httparse=1.2.4 \
+ hyper-tls=0.1.2 \
+ hyper=0.11.18 \
+ idna=0.1.4 \
+ iovec=0.1.2 \
+ itertools=0.7.6 \
+ itoa=0.3.4 \
+ kernel32-sys=0.2.2 \
+ language-tags=0.2.2 \
+ lazy_static=0.2.11 \
+ lazy_static=1.0.0 \
+ lazycell=0.6.0 \
+ libc=0.2.36 \
+ libflate=0.1.14 \
+ libz-sys=1.0.18 \
+ log=0.3.9 \
+ log=0.4.1 \
+ lzma-sys=0.1.9 \
+ markdown=0.2.0 \
+ matches=0.1.6 \
+ memchr=0.1.11 \
+ memchr=2.0.1 \
+ mime=0.3.5 \
+ mime_guess=2.0.0-alpha.3 \
+ miniz-sys=0.1.10 \
+ mio=0.6.13 \
+ miow=0.2.1 \
+ native-tls=0.1.5 \
+ net2=0.2.31 \
+ num-traits=0.1.43 \
+ num-traits=0.2.0 \
+ num_cpus=1.8.0 \
+ ole32-sys=0.2.0 \
+ openssl-probe=0.1.2 \
+ openssl-sys=0.9.25 \
+ openssl=0.9.24 \
+ percent-encoding=1.0.1 \
+ phf=0.7.21 \
+ phf_codegen=0.7.21 \
+ phf_generator=0.7.21 \
+ phf_shared=0.7.21 \
+ pipeline=0.5.0 \
+ pkg-config=0.3.9 \
+ quote=0.3.15 \
+ rand=0.3.22 \
+ rand=0.4.2 \
+ redox_syscall=0.1.37 \
+ redox_termios=0.1.1 \
+ regex-syntax=0.3.9 \
+ regex-syntax=0.4.2 \
+ regex=0.1.80 \
+ regex=0.2.6 \
+ relay=0.1.1 \
+ remove_dir_all=0.3.0 \
+ reqwest=0.8.4 \
+ rustc-demangle=0.1.5 \
+ safemem=0.2.0 \
+ same-file=1.0.2 \
+ schannel=0.1.10 \
+ scoped-tls=0.1.0 \
+ scopeguard=0.3.3 \
+ security-framework-sys=0.1.16 \
+ security-framework=0.1.16 \
+ semver-parser=0.7.0 \
+ semver=0.9.0 \
+ serde=1.0.27 \
+ serde_derive=1.0.27 \
+ serde_derive_internals=0.19.0 \
+ serde_json=1.0.9 \
+ serde_urlencoded=0.5.1 \
+ sha2=0.7.0 \
+ siphasher=0.2.2 \
+ slab=0.3.0 \
+ slab=0.4.0 \
+ smallvec=0.2.1 \
+ socket2=0.3.1 \
+ strsim=0.7.0 \
+ syn=0.11.11 \
+ synom=0.11.3 \
+ take=0.1.0 \
+ tar=0.4.14 \
+ tempdir=0.3.6 \
+ tempfile=2.2.0 \
+ term=0.4.6 \
+ termion=1.5.1 \
+ textwrap=0.9.0 \
+ thread-id=2.0.0 \
+ thread_local=0.2.7 \
+ thread_local=0.3.5 \
+ time=0.1.39 \
+ tokio-core=0.1.12 \
+ tokio-io=0.1.5 \
+ tokio-proto=0.1.1 \
+ tokio-service=0.1.0 \
+ tokio-tls=0.1.4 \
+ toml=0.4.5 \
+ typenum=1.9.0 \
+ unicase=1.4.2 \
+ unicase=2.1.0 \
+ unicode-bidi=0.3.4 \
+ unicode-normalization=0.1.5 \
+ unicode-width=0.1.4 \
+ unicode-xid=0.0.4 \
+ unreachable=1.0.0 \
+ url=1.6.0 \
+ utf8-ranges=0.1.3 \
+ utf8-ranges=1.0.0 \
+ uuid=0.5.1 \
+ vcpkg=0.2.2 \
+ vec_map=0.8.0 \
+ version_check=0.1.3 \
+ void=1.0.2 \
+ wait-timeout=0.1.5 \
+ walkdir=2.1.3 \
+ winapi-build=0.1.1 \
+ winapi-i686-pc-windows-gnu=0.4.0 \
+ winapi-x86_64-pc-windows-gnu=0.4.0 \
+ winapi=0.2.8 \
+ winapi=0.3.4 \
+ winreg=0.5.0 \
+ ws2_32-sys=0.2.1 \
+ xattr=0.1.11 \
+ xz2=0.1.4; do
+ dep="$(echo "$dependency" | cut -d= -f1)"
+ ver="$(echo "$dependency" | cut -d= -f2)"
+
+ tar xvf $CWD/$dep-$ver.crate
+
+ touch $dep-$ver/.cargo-ok
+
+ # generate checksum
+ {
+ printf "{\n"
+ printf ' "files": {\n'
+
+ (
+ cd $dep-$ver
+ find . -type f -print0 | xargs -0 sha256sum | sed -n '/\.cargo-checksum\.json/!p' | sed 's/\.\///;s/^\([^ ]*\)[[:space:]][[:space:]]*\(.*\)$/"\2":"\1",/'
+ ) | sed '$ s/,$//'
+
+ printf " },\n"
+ printf ' "package": "'
+
+ sha256sum "$CWD/$dep-$ver.crate" | cut -f1 -d' ' | sed 's/$/"/'
+
+ printf "}\n"
+ } | python -c "import sys, json; data = sys.stdin.read(); print json.dumps(json.loads(data), sort_keys=True, indent=4, separators=(',', ' : '))" > $dep-$ver/.cargo-checksum.json
+ done
+)
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cargo build --release --features no-self-update $CARGOTARGET
+
+mkdir -p $PKG/usr/bin/
+
+find target -name rustup-init -exec install -m 755 {} $PKG/usr/bin/rustup \;
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/share/bash-completion/completions
+$PKG/usr/bin/rustup completions bash > $PKG/usr/share/bash-completion/completions/rustup
+
+mkdir -p $PKG/usr/share/zsh/site-functions
+$PKG/usr/bin/rustup completions zsh > $PKG/usr/share/zsh/site-functions/_rustup
+
+chmod 0644 $PKG/usr/share/zsh/site-functions/_rustup $PKG/usr/share/bash-completion/completions/rustup
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE-APACHE LICENSE-MIT README.md $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}